/***********************************************************************************************************************
 *
 * blueBill Core - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://kenai.com/hg/bluebill~core-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.taxonomy.elmo;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public final class ElmoTaxonomyVocabulary
  {
    private ElmoTaxonomyVocabulary()
      {
      }

    public static final String NS_TAXO_BASE = "http://bluebill.tidalwave.it/rdf/taxo/2010/08/28#";

    public static final String URI_TAXONOMY = NS_TAXO_BASE + "TaxonomyScheme";

    public static final String ID_TAXONOMY_PREFIX = "http://bluebill.tidalwave.it/taxonomy/";

    public static final String ID_TAXON_RANK_CLASS      = "class";
    public static final String ID_TAXON_RANK_ORDER      = "order";
    public static final String ID_TAXON_RANK_FAMILY     = "family";
    public static final String ID_TAXON_RANK_SUBFAMILY  = "subfamily";
    public static final String ID_TAXON_RANK_GENUS      = "genus";
    public static final String ID_TAXON_RANK_SPECIES    = "species";
    public static final String ID_TAXON_RANK_SUBSPECIES = "subspecies";

    public static final String NS_DARWIN_CORE         = "http://rs.tdwg.org/dwc/2009-12-07/terms/";
    public static final String URI_TAXON              = NS_DARWIN_CORE + "Taxon";
    public static final String URI_SCIENTIFIC_NAME    = NS_DARWIN_CORE + "scientificName";
    public static final String URI_SCIENTIFIC_NAME_ID = NS_DARWIN_CORE + "scientificNameID";
    public static final String URI_SPECIFIC_EPITHET   = NS_DARWIN_CORE + "specificEpithet";
    public static final String URI_TAXON_RANK         = NS_DARWIN_CORE + "taxonRank";
  }
